//MUST HAVE THESE VARIABLES
const ONCLICK	= 0;
const ONDBLCLICK	= 1;
const ONMOUSEDOWN	= 3;
const ONMOUSEUP	= 4;

var MouseLog = {
	//time till last click.
	timeLeft: 0,
	timeMiddle: 0,
	timeRight: 0,
	// the mouse buttons currently pressed.
	clickID: new Array(),
	// type = type of click, ie ONDBLCLICK, ONCLICK, etc
	clickType: new Array(),
	// action = the action (function) to execute when type is true
	clickAction: new Array(),
	// button = the mouse button pressed to trigger an action. Mouse commands are: MOUSE_LEFT, MOUSE_RIGHT, MOUSE_MIDDLE
	clickButton: new Array(),
	
	addClick: function(clickID)
	{
		for(var i in this.clickID)
			if(this.clickID[i] == clickID)
				return;
		
		this.checkForTriggers(clickID, ONMOUSEDOWN);
		
		this.clickID.push(clickID);
	},
	runMouseActions: function()
	{
		for(var i=0;i<this.clickID.length;i++)
		{
			if(!IsMouseButtonPressed(this.clickID[i]))
			{
				if(this.clickID[i] == MOUSE_LEFT)
					this.timeLeft = GetTime();
				else if(this.clickID[i] == MOUSE_MIDDLE)
					this.timeMiddle = GetTime();
				else if(this.clickID[i] == MOUSE_RIGHT)
					this.timeRight = GetTime();
				
				this.checkForTriggers(this.clickID[i], ONMOUSEUP);
				
				if(this.hasBothClicks(this.clickID[i]))
					this.checkForTriggers(this.clickID[i], ONCLICK);
				
				this.clickID.splice(i,1);
				continue;
			}
			// DOUBLE CLICK
			var clickTime = (this.clickID[i] == MOUSE_LEFT) ? this.timeLeft : (this.clickID[i] == MOUSE_MIDDLE) ? this.timeMiddle : this.timeRight;
			if(GetTime() - clickTime <= 150)
				this.checkForTriggers(this.clickID[i], ONDBLCLICK);
		}
	},
	hasBothClicks: function(clickID)
	{
		var hasClicks = 0;
		for(var i=0;i<this.clickType.length;i++)
		{
			if(clickID == this.clickButton[i])
			{
				if(this.clickType[i] == ONMOUSEDOWN || this.clickType[i] == ONMOUSEUP)
					hasClicks++;
			}
		}
		return hasClicks == 2;
	},
	checkForTriggers: function(button, type)
	{
		for(var i=0;i<this.clickType.length;i++)
			if(this.clickButton[i] == button && this.clickType[i] == type)
				eval(this.clickAction[i]);
	},
	// MOUSE CLICK ACTIONS
	addAction: function(button, type, action)
	{
		this.clickButton.push(button);
		this.clickType.push(type);
		this.clickAction.push(action);
	},
	removeAction: function(button, type)
	{
		for(var i=0;i<this.clickType.length;i++)
		{
			if(this.clickButton[i] == button && this.clickType[i] == type)
			{
				this.clickButton.splice(i,1);
				this.clickType.splice(i,1);
				this.clickAction.splice(i,1);
			}
		}
	},
};